//
//  WGBRadarChartView.m
//  hahda
//
//  Created by Wangguibin on 2017/3/13.
//  Copyright © 2017年 王贵彬. All rights reserved.
//

#import "WGBRadarChartView.h"
#import "JJRadarChart.h"

@interface WGBRadarChartView ()<JJRadarChartDataSource, JJRadarChartDelegate>

@property (nonatomic,strong) JJRadarChart *chart;
@property (nonatomic,strong) NSArray *titlesArray;
@property (nonatomic,strong) NSMutableArray *dataSource;

@end

@implementation WGBRadarChartView

- (NSMutableArray *)dataSource
{
	if (_dataSource==nil) {
		_dataSource =[[NSMutableArray alloc]init];
	}
	return _dataSource;
}

- (JJRadarChart *)chart{
	if (!_chart) {
		_chart =[[JJRadarChart alloc] initWithFrame:CGRectMake(0, 0, self.bounds.size.width , self.bounds.size.width)];
		_chart.center = CGPointMake(half(self.frame.size.width), half(self.frame.size.height));
			//设置数据源
		_chart.dataSource = self;
			//设置代理
		_chart.delegate = self;
			//添加控件
		[self addSubview: _chart];
	}
	return _chart;
}

- (NSArray *)titlesArray{
	if (!_titlesArray) {
		_titlesArray = @[
						@"母乳喂养指导",@"人工喂养",@"二便观察",@"生长指标测量",
						@"行业经验", @"月子营养搭配",@"早教启蒙",@"沟通技巧",
						@"证书种类",@"气质形象",@"普通话",@"教育背景",@"宝宝护理",
						@"妈妈护理",@"常见疾病预防",@"异常问题处理"
						 ];
	}
	return _titlesArray;
}

- (instancetype)initWithFrame:(CGRect)frame
{
	self = [super initWithFrame:frame];
	if (self) {
		[self chart];
	}
	return self;
}

- (void)setCharts:(NSArray *)charts{
	_charts = charts;
	[charts enumerateObjectsUsingBlock:^(NSString *pointStr, NSUInteger index, BOOL * _Nonnull stop) {
		NSString *title = [NSString stringWithFormat:@"%@%@",self.titlesArray[index],pointStr];
		[self.dataSource addObject: title];
	}];
	dispatch_async(dispatch_get_main_queue(), ^{
		[self.chart reloadData];
	});
}

#pragma mark - JJRadarChartDataSource
- (NSInteger)numberOfItemsInRadarChart:(JJRadarChart *)radarChart {
	return self.dataSource.count;
}
- (NSInteger)radarChart:(JJRadarChart *)radarChart maxCountAtIndex:(NSInteger)index {
		//每组最大100分
	return 100;
}
- (NSInteger)radarChart:(JJRadarChart *)radarChart rankAtIndex:(NSInteger)index {
	return [self.charts[index] integerValue];
}

	///标题
- (NSString *)radarChart:(JJRadarChart *)radarChart titleOfItemAtIndex:(NSInteger)index {
	return self.dataSource[index];
}

	/// 富文本标题
- (NSMutableAttributedString *)radarMuableChart:(JJRadarChart *)radarChart titleOfItemAtIndex:(NSInteger)index{
	NSMutableAttributedString *attrbuteStr =[[NSMutableAttributedString alloc] initWithString: self.dataSource[index]];
	NSString *str = self.dataSource[index];
		/// 取出数字部分 上颜色
	NSScanner *scanner = [NSScanner scannerWithString: str];
	[scanner scanUpToCharactersFromSet:[NSCharacterSet decimalDigitCharacterSet] intoString:nil];
	int number;
	[scanner scanInt:&number];
	NSString *num=[NSString stringWithFormat:@"%d",number];
	NSRange range = NSMakeRange(str.length - num.length , num.length);
	[attrbuteStr addAttribute:NSForegroundColorAttributeName  value: colorRGB(154, 88, 206) range: range];
	range = NSMakeRange(0, str.length - num.length);
	[attrbuteStr addAttribute: NSForegroundColorAttributeName value:colorRGB(125, 126, 127) range:range];
	return attrbuteStr;
}

#pragma mark - JJRadarChartDelegate
- (void)radarChart:(JJRadarChart *)radarChart didDisplayCurrentPoint:(CGPoint)point atIndex:(NSInteger)index {

//  NSLog(@"当前%zd点在%@", index, NSStringFromCGPoint(point));
}
- (void)radarChart:(JJRadarChart *)radarChart didDisplayMaxPoint:(CGPoint)point atIndex:(NSInteger)index {

//NSLog(@"最大%zd点在%@", index, NSStringFromCGPoint(point));
}

	/// 点击按钮
- (void)radarChart:(JJRadarChart *)radarChart didSelectedItemAtIndex:(NSInteger)index {

}


@end
